import * as cdk from '@aws-cdk/core';
/**
 * @experimental
 */
export interface ISlackEventNotify {
    /**
     * (experimental) slack Webhook Url for Lambda send message to slack.
     *
     * @experimental
     */
    readonly slackWebhookUrl: string;
    /**
     * (experimental) slack Channel Name for Lambda send message to slack.
     *
     * @experimental
     */
    readonly slackChannelName: string;
}
/**
 * @experimental
 */
export interface EventNotifyProps {
    /**
     * (experimental) Line Notify Token for Lambda send notify permisson.
     *
     * @experimental
     */
    readonly lineNotifyToken?: string | undefined;
    /**
     * (experimental) Notify target to Slack channel.
     *
     * @experimental
     */
    readonly slack?: ISlackEventNotify;
}
/**
 * @experimental
 */
export declare class EventNotify extends cdk.Construct {
    /**
     * @experimental
     */
    constructor(scope: cdk.Construct, id: string, props?: EventNotifyProps);
}
